#include <Profiles/Lev/DataPages/RX/ANTPLUS_LevBatteryInformation.h>
#include <Profiles/Lev/ANTPLUS_LevPrivateDefines.h>

LevBatteryInformation::LevBatteryInformation(AntRxDataResponse& dp) : LevBaseMainDataPage(dp) {
}

uint16_t LevBatteryInformation::getChargingCycleCount() {
    return (uint16_t)getData(ANTPLUS_LEV_DATAPAGE_BATTERYINFORMATION_CHARGINGCYCLECOUNT_LSB_BYTE) + (((uint16_t)getData(ANTPLUS_LEV_DATAPAGE_BATTERYINFORMATION_CHARGINGCYCLECOUNT_MSB_BYTE) & ANTPLUS_LEV_DATAPAGE_BATTERYINFORMATION_CHARGINGCYCLECOUNT_MSB_MASK) << ANTPLUS_LEV_DATAPAGE_BATTERYINFORMATION_CHARGINGCYCLECOUNT_MSB_SHIFT);
}

uint16_t LevBatteryInformation::getFuelConsumption() {
    return (((uint16_t)getData(ANTPLUS_LEV_DATAPAGE_BATTERYINFORMATION_FUELCONSUMPTION_MSB_BYTE) & ANTPLUS_LEV_DATAPAGE_BATTERYINFORMATION_FUELCONSUMPTION_MSB_MASK) << ANTPLUS_LEV_DATAPAGE_BATTERYINFORMATION_FUELCONSUMPTION_MSB_SHIFT) + (uint16_t)getData(ANTPLUS_LEV_DATAPAGE_BATTERYINFORMATION_FUELCONSUMPTION_LSB_BYTE);
}

uint8_t LevBatteryInformation::getBatteryVoltage() {
    return getData(ANTPLUS_LEV_DATAPAGE_BATTERYINFORMATION_BATTERYVOLTAGE_BYTE);
}

uint16_t LevBatteryInformation::getDistanceOnCurrentCharge() {
    return getData(ANTPLUS_LEV_DATAPAGE_BATTERYINFORMATION_DISTANCEONCURRENTCHARGE_LSB_BYTE) + (getData(ANTPLUS_LEV_DATAPAGE_BATTERYINFORMATION_DISTANCEONCURRENTCHARGE_MSB_BYTE) << ANTPLUS_LEV_DATAPAGE_BATTERYINFORMATION_DISTANCEONCURRENTCHARGE_MSB_SHIFT);
}
